/*!
 * Copyright (c) 2012 - 2023, Anaconda, Inc., and Bokeh Contributors
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 * 
 * Neither the name of Anaconda nor the names of any contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */
(function(root, factory) {
  factory(root["Bokeh"], undefined);
})(this, function(Bokeh, version) {
  let define;
  return (function(modules, entry, aliases, externals) {
    const bokeh = typeof Bokeh !== "undefined" && (version != null ? Bokeh[version] : Bokeh);
    if (bokeh != null) {
      return bokeh.register_plugin(modules, entry, aliases);
    } else {
      throw new Error("Cannot find Bokeh " + version + ". You have to load it prior to loading plugins.");
    }
  })
({
"ecf49f9c64": function _(e,s,t,o,r){o();const a=e("tslib").__importStar(e("ef403b5ad2"));t.PaneljsTree=a;(0,e("@bokehjs/base").register_models)(a)},
"ef403b5ad2": function _(e,s,t,c,o){c();const r=e("tslib").__importStar(e("e4c337fccb"));t.jsTree=r;(0,e("@bokehjs/base").register_models)(r)},
"e4c337fccb": function _(e,t,s,o,i){var _;o();const n=e("@bokehjs/core/dom"),l=e("bfe8e8c0eb");class r extends l.HTMLBoxView{initialize(){super.initialize(),this._last_selected=[]}connect_signals(){console.log("connect"),super.connect_signals(),this.connect(this.model.properties.data.change,(()=>this._update_tree_from_data())),this.connect(this.model.properties.value.change,(()=>this._update_selection_from_value())),this.connect(this.model.properties._new_nodes.change,(()=>this._update_tree_from_new_nodes())),this.connect(this.model.properties.show_icons.change,(()=>this._setShowIcons())),this.connect(this.model.properties.show_dots.change,(()=>this._setShowDots())),this.connect(this.model.properties.multiple.change,(()=>this._setMultiple())),console.log(this.model.show_dots),console.log(this.model.show_icons)}render(){super.render(),this._id="_"+Math.random().toString(36).substr(2,9),console.log(this._id),this._container=(0,n.div)({id:this._id,style:"overflow: auto; minHeight: 200px; minWidth: 200px;"}),(0,l.set_size)(this._container,this.model),this.shadow_el.appendChild(this._container),console.log(this._container);this._jstree=jQuery(this._container).jstree(Object.assign({core:{data:this.model.data,check_callback:!0,multiple:this.model.multiple,themes:{dots:this.model.show_dots,icons:this.model.show_icons}},plugins:this.model.plugins},{checkbox:{three_state:!1,cascade:"undetermined"}})),this.init_callbacks()}init_callbacks(){this._jstree.on("refresh.jstree",(({},{})=>this._update_selection_from_value())),this._jstree.on("changed.jstree",((e,t)=>this._update_code_from_editor(e,t))),this._jstree.on("before_open.jstree",((e,t)=>this._listen_for_node_open(e,t)))}_update_code_from_editor({},e){this.model.value=e.instance.get_selected()}_update_selection_from_value(){console.log("last selected: ",this._last_selected);let e=this._last_selected.filter((e=>!this.model.value.includes(e)));console.log("values: ",this.model.value),this._jstree.jstree(!0).select_node(this.model.value),console.log("deselected: ",e),this._jstree.jstree(!0).deselect_node(e),this._last_selected=this.model.value}_update_tree_from_new_nodes(){console.log("new nodes: ",this.model._new_nodes);for(let e of this.model._new_nodes)this._jstree.jstree(!0).create_node(e.parent,e,"first");this._jstree.jstree(!0).settings.core.data=this._jstree.jstree(!0).get_json(null,{no_li_attr:!0,no_a_attr:!0,no_data:!0}),this.model.data=this._jstree.jstree(!0).settings.core.data}_update_tree_from_data(){console.log("updating data"),this._jstree.jstree(!0).settings.core.data=this.model.data,console.log("flat tree: ",this.model._flat_tree),this.model._flat_tree=this._jstree.jstree(!0).get_json(null,{flat:!0})}_setShowIcons(){this.model.show_icons?this._jstree.jstree(!0).show_icons():this._jstree.jstree(!0).hide_icons()}_setShowDots(){this.model.show_dots?this._jstree.jstree(!0).show_dots():this._jstree.jstree(!0).hide_dots()}_setMultiple(){this._jstree.jstree(!0).settings.core.multiple=this.model.multiple}_update_tree_theme_from_model(){this._jstree.jstree(!0).refresh(!1,!0)}_listen_for_node_open({},e){console.log("node opened"),console.log("openeing node: ",e.node),this.model._last_opened=e.node}}s.jsTreePlotView=r,r.__name__="jsTreePlotView";class d extends l.HTMLBox{constructor(e){super(e)}}s.jsTreePlot=d,_=d,d.__name__="jsTreePlot",d.__module__="panel_jstree.bokeh_extensions.jstree",_.prototype.default_view=r,_.define((({Array:e,Any:t,Boolean:s})=>({value:[e(t),[]],data:[e(t),[]],plugins:[e(t),[]],multiple:[s,!0],show_icons:[s,!0],show_dots:[s,!0],_last_opened:[t,{}],_new_nodes:[t,{}],_flat_tree:[e(t),[]]})))},
"bfe8e8c0eb": function _(e,t,i,s,h){s();const a=e("@bokehjs/core/dom"),l=e("@bokehjs/core/util/types"),n=e("@bokehjs/models/widgets/widget"),d=e("@bokehjs/models/layouts/layout_dom");class r extends n.WidgetView{async lazy_initialize(){await super.lazy_initialize(),"not_started"!=this.provider.status&&"loading"!=this.provider.status||this.provider.ready.connect((()=>{this.contains_tex_string(this.model.text)&&this.render()}))}connect_signals(){super.connect_signals(),this.connect(this.model.change,(()=>{this.render()}))}has_math_disabled(){return this.model.disable_math||!this.contains_tex_string(this.model.text)}render(){super.render(),o(this.el,this.model),this.container=(0,a.div)(),o(this.container,this.model,!1),this.shadow_el.appendChild(this.container),"failed"!=this.provider.status&&"loaded"!=this.provider.status||(this._has_finished=!0)}}function o(e,t,i=!0){let s=null!=t.width?"fixed":"fit",h=null!=t.height?"fixed":"fit";const{sizing_mode:a,margin:n}=t;if(null!=a)if("fixed"==a)s=h="fixed";else if("stretch_both"==a)s=h="max";else if("stretch_width"==a)s="max";else if("stretch_height"==a)h="max";else switch(a){case"scale_width":s="max",h="min";break;case"scale_height":s="min",h="max";break;case"scale_both":s="max",h="max";break;default:throw new Error("unreachable")}let d,r;i?(0,l.isArray)(n)?4===n.length?(r=n[0]+n[2],d=n[1]+n[3]):(r=2*n[0],d=2*n[1]):null==n?r=d=0:d=r=2*n:r=d=0,"fixed"==s&&t.width?e.style.width=t.width+"px":"max"==s&&(e.style.width=d?`calc(100% - ${d}px)`:"100%"),null!=t.min_width&&(e.style.minWidth=t.min_width+"px"),null!=t.max_width&&(e.style.maxWidth=t.max_width+"px"),"fixed"==h&&t.height?e.style.height=t.height+"px":"max"==h&&(e.style.height=r?`calc(100% - ${r}px)`:"100%"),null!=t.min_height&&(e.style.minHeight=t.min_height+"px"),null!=t.max_width&&(e.style.maxHeight=t.max_height+"px")}i.PanelMarkupView=r,r.__name__="PanelMarkupView",i.set_size=o;class _ extends d.LayoutDOMView{render(){super.render(),o(this.el,this.model)}watch_stylesheets(){this._initialized_stylesheets={};for(const e of this._applied_stylesheets){const t=e.el;t instanceof HTMLLinkElement&&(this._initialized_stylesheets[t.href]=!1,t.addEventListener("load",(()=>{this._initialized_stylesheets[t.href]=!0,Object.values(this._initialized_stylesheets).every(Boolean)&&this.style_redraw()})))}}style_redraw(){}get child_models(){return[]}}i.HTMLBoxView=_,_.__name__="HTMLBoxView";class c extends d.LayoutDOM{constructor(e){super(e)}}i.HTMLBox=c,c.__name__="HTMLBox"},
}, "ecf49f9c64", {"index":"ecf49f9c64","bokeh_extensions/index":"ef403b5ad2","bokeh_extensions/jstree":"e4c337fccb","bokeh_extensions/layout":"bfe8e8c0eb"}, {});});
